# Google APIs Client Library for Objective-C #

**Project site** <https://github.com/google/google-api-objectivec-client><br>
**Discussion group** <http://groups.google.com/group/google-api-objectivec-client>

[![Build Status](https://travis-ci.org/google/google-api-objectivec-client.svg?branch=master)](https://travis-ci.org/google/google-api-objectivec-client)

Written by Google, this library is a flexible and efficient Objective-C
framework for accessing JSON APIs.

This is the recommended library for accessing JSON-based Google APIs for iOS and
Mac OS X applications.  The library is compatible with applications built for
iOS 3 and later, and Mac OS X 10.5 and later.

**To get started** with Google  APIs and the Objective-C client library,  read
the [wiki](https://github.com/google/google-api-objectivec-client/wiki)
and study the
[example applications](https://github.com/google/google-api-objectivec-client/tree/master/Examples).

Generated interfaces for Google APIs are in the
[services folder](https://github.com/google/google-api-objectivec-client/tree/master/Source/Services).
Library changes are documented in the
[release notes](https://github.com/google/google-api-objectivec-client/blob/master/ReleaseNotes.md).

Google APIs with generated interfaces include
- [AdExchange Buyer](https://developers.google.com/ad-exchange/buyer-rest/)
- [AdExchange Seller](https://developers.google.com/ad-exchange/seller-rest/)
- [AdSense](https://developers.google.com/adsense/)
- [AdSense Host](https://developers.google.com/adsense/host/)
- [Analytics](https://developers.google.com/analytics/)
- [Blogger](https://developers.google.com/blogger/)
- [Books](https://developers.google.com/books/)
- [Calendar](https://developers.google.com/google-apps/calendar/)
- [Civic Info](https://developers.google.com/civic-information/)
- [Cloud Save (AppState)](https://developers.google.com/games/services/common/concepts/cloudsave)
- [Cloud Storage](https://developers.google.com/storage/)
- [Compute Engine](https://developers.google.com/compute/)
- [DoubleClick Bid Manager](https://developers.google.com/bid-manager/)
- [Drive](https://developers.google.com/drive/)
- [Fitness](https://developers.google.com/fit/)
- [Gmail](https://developers.google.com/gmail/)
- [Maps Engine](https://developers.google.com/maps-engine/)
- [Mirror](https://developers.google.com/glass/about/) for Google Glass
- [Groups Settings](https://developers.google.com/google-apps/groups-settings/)
- Latitude ([deprecated](https://support.google.com/gmm/answer/3001634?p=maps_android_latitude&rd=1))
- [Plus](https://developers.google.com/+/api/)
- [Plus Domains](https://developers.google.com/+/domains/)
- Shopping ([deprecated](http://googleblog.blogspot.jp/2013/03/a-second-spring-of-cleaning.html))
- [Spectrum Database](https://developers.google.com/spectrum/)
- [QPX Express](https://developers.google.com/qpx-express/)
- [Tasks](https://developers.google.com/google-apps/tasks/)
- [URL Shortener](https://developers.google.com/url-shortener/)
- [Webmaster Tools](https://developers.google.com/webmaster-tools/)
- [YouTube](https://developers.google.com/youtube/v3/)

The library may also be used
[without generated interfaces](https://github.com/google/google-api-objectivec-client/wiki#using-apis-without-generated-classes)
with JSON REST and JSON-RPC APIs.

**If you have a problem** or want a new feature to be included in the library,
please join the
[discussion group](http://groups.google.com/group/google-api-objectivec-client).
Be sure to include
[http logs](https://github.com/google/google-api-objectivec-client/wiki#logging-http-server-traffic)
for requests and responses when posting questions. Bugs may also be submitted
on the [issues list](https://github.com/google/google-api-objectivec-client/issues).

**Externally-included projects**: The library includes code from the separate
projects [GTM HTTP Fetcher](https://github.com/google/gtm-http-fetcher),
[GTM OAuth 2](https://github.com/google/gtm-oauth2), and
[json-framework](http://code.google.com/p/json-framework/).

**Google Data APIs**: The library for older, XML-based APIs is
[still available](https://github.com/google/gdata-objectivec-client).

Other useful classes for Mac and iOS developers are available in the
[Google Toolbox for Mac](https://github.com/google/google-toolbox-for-mac).
